<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Datasets' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Jeux de données
      </span>
    </div>
    <b-container fluid>
      <b-overlay
        no-wrap
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      />
      <ValidationObserver v-slot="{ handleSubmit }">
        <b-row>
          <b-col
            cols="8"
            class="detail-forms"
            style="overflow-x: hidden;"
          >
            <ValidationObserver v-slot="{ handleSubmit }">
              <form>
                <DatasetForm
                  :mode="'datasetDetail'"
                  :defaultForm="form"
                  @update="setForm"
                />
                <h3
                  class="line-header"
                >
                  <img
                    src="@/assets/icons/file_document_sheet.svg"
                    alt="Icône calendrier"
                  /> Source de la donnée
                </h3>
                <b-row style="height: auto;">
                  <b-col
                    cols="12"
                  >
                    <b-overlay
                      no-wrap
                      :show="loadingResource"
                      :variant="'white'"
                      :opacity="0.7"
                      :blur="'2px'"
                      rounded="sm"
                    />
                    <FileUploadResourceEditor
                      v-if="source && source.data_source._model_name === 'fileupload'"
                      ref="resourceComponent"
                      :resource="source"
                      :resource-data="resourceData"
                      @update="updateFileUploadFile"
                      @delete="afterResourceChange"
                    />
                    <FTPResourceEditor
                      v-else-if="source && source.data_source._model_name === 'ftp'"
                      ref="resourceComponent"
                      :resource="source"
                      :resource-data="resourceData"
                      @update="updateFTPFile"
                      @delete="afterResourceChange"
                    />
                    <HrefResourceEditor
                      v-else-if="source && source.data_source._model_name === 'href'"
                      ref="resourceComponent"
                      :resource="source"
                      :resource-data="resourceData"
                      @update="updateHrefFile"
                      @delete="afterResourceChange"
                    />
                    <div v-if="currentDataset.resource_source && currentDataset.resource_source._processing" class="form-row">
                      <div class="form-group col">
                        <b-overlay
                          :show="reLoadindResource"
                          :variant="'white'"
                          :opacity="0.7"
                          :blur="'2px'"
                          rounded="sm"
                        >
                          <div
                            style="margin-left: 0;"
                            :class="currentDataset.resource_source._processing.state === 'FAILURE' ? 'alert-danger' : 'alert-info'"
                            class="alert"
                            role="alert"
                          >
                            <p style="font-size: 0.9rem;">
                              <span v-if="currentDataset.resource_source._processing.state === 'FAILURE'">
                                Le traitement de la ressource a échoué.
                                Vous pouvez consulter la tâche
                              </span>
                              <span v-else>
                                La ressource est en cours de traitement.
                                Vous pouvez suivre son avancement
                              </span>
                              <router-link
                                :to="{ name: 'TaskDetail', params: { id: currentDataset.resource_source._processing.id }}"
                              >
                                ici
                              </router-link>.
                            </p>
                          </div>
                          <ResourceCreator
                            v-if="!source && currentDataset.resource_source._processing.state === 'FAILURE'"
                            @set="setResource"
                          />
                        </b-overlay>
                      </div>
                    </div>
                    <div v-else-if="!source" class="form-row">
                      <div class="form-group col">
                          <p style="font-size: 0.9rem;">
                            Aucune source de donnée n'est rattachée.
                          </p>
                          <ResourceCreator
                            :required="false"
                            @set="setResource"
                          />
                      </div>
                    </div>
                    <div
                      v-if="
                        !source ||
                        (
                          currentDataset.resource_source &&
                          currentDataset.resource_source._processing &&
                          currentDataset.resource_source._processing.state === 'FAILURE'
                        )
                      "
                      class="form-footer"
                      style="margin: 1em 0 0 0; justify-content: flex-end;"
                    >
                      <b-button
                        variant="primary"
                        :disabled="!newResource"
                        style="font-size: 1em;"
                        @click="handleSubmit(createResource)"
                      >
                        Charger
                      </b-button>
                    </div>
                  </b-col>
                </b-row>
                <h3
                  class="line-header"
                >
                  <img
                    src="@/assets/icons/files_ressources.svg"
                    alt="Icône calendrier"
                  /> Annexes
                </h3>
                <b-row style="height: auto;">
                  <b-col
                    cols="12"
                  >
                  <div v-if="!annexes.length" class="form-row">
                    <div class="form-group col">
                      <p style="font-size: 0.9rem;">
                        Aucune annexe rattachée à ce jeu de donnée.
                      </p>
                    </div>
                  </div>
                  <div v-else>
                    <b-overlay
                      no-wrap
                      :show="loadingAnnexe"
                      :variant="'white'"
                      :opacity="0.7"
                      :blur="'2px'"
                      rounded="sm"
                    />
                    <div
                      v-for="annexe of annexes"
                      :key="annexe.id"
                    >
                      <FileUploadResourceEditor
                        v-if="annexe && annexe.data_source._model_name === 'fileupload'"
                        ref="annexComponent"
                        :resource="annexe"
                        :type="'annexe'"
                        @update="updateFileUploadFile"
                        @delete="afterResourceChange"
                      />
                      <FTPResourceEditor
                        v-else-if="annexe && annexe.data_source._model_name === 'ftp'"
                        ref="annexComponent"
                        :resource="annexe"
                        :type="'annexe'"
                        @update="updateFTPFile"
                        @delete="afterResourceChange"
                      />
                      <HrefResourceEditor
                        v-else-if="annexe && annexe.data_source._model_name === 'href'"
                        ref="annexComponent"
                        :resource="annexe"
                        :type="'annexe'"
                        @update="updateHrefFile"
                        @delete="afterResourceChange"
                      />
                    </div>
                  </div>
                  <AddAnnexe
                    v-if="isAddingAnnexe"
                    :required="true"
                    @close="afterResourceChange"
                  />
                  <button
                    v-if="isAddingAnnexe"
                    class="add-button"
                    @click.prevent="isAddingAnnexe = false"
                  >
                    <b-icon-dash />
                    Annuler
                  </button>
                  <button
                    v-else
                    class="add-button"
                    @click.prevent="isAddingAnnexe = true"
                  >
                    <b-icon-plus />
                    Ajouter une annexe
                  </button>
                  </b-col>
                </b-row>
              </form>
            </ValidationObserver>
          </b-col>
          <b-col
            cols="4"
            class="detail-card"
          >
            <div class="card-permissions-container">
              <DatasetCard
                :key="`dataset-card-${cardKey}`"
                :dataset="currentDataset"
              />
              <div class="permissions-dropdown">
                <label>
                  Niveau de permission par défaut
                </label>
                <b-overlay :show="busy" rounded="lg" opacity="0.6">
                  <template #overlay>
                    <div class="d-flex align-items-center">
                      <b-spinner small type="grow" variant="secondary"></b-spinner>
                      <b-spinner type="grow" variant="dark"></b-spinner>
                      <b-spinner small type="grow" variant="secondary"></b-spinner>
                      <span class="sr-only">Please wait...</span>
                    </div>
                  </template>
                  <Multiselect
                    v-model="permissionLevel"
                    :options="permissionLevels"
                    track-by="code"
                    label="label"
                    selectLabel=""
                    selectedLabel=""
                    deselectLabel=""
                    :searchable="false"
                    placeholder="Permission par défaut"
                    @select="askForChangePermissionLevel"
                  />
                </b-overlay>
              </div>
              <div class="access-permissions" style="width: 100%; text-align: center;">
                <b-button
                  variant="outline-secondary"
                  @click="$router.push({
                    name: 'DatasetPermissions',
                    params: {
                      id: currentDataset.id,
                    }
                  })"
                >
                  <img
                    src="@/assets/icons/access_unlock_open.svg"
                    alt="Icône cadenas"
                  />
                  ACCES A LA DONNEE
                </b-button>
              </div>
              <div class="side-footer">
                <b-button
                  variant="danger"
                  @click="askToDeleteDataset"
                >
                  Supprimer
                </b-button>
                <!-- <b-button
                  variant="outline-secondary"
                  @click="$router.go(-1)"
                >
                  Annuler
                </b-button> -->
                <b-button
                  variant="outline-secondary"
                  @click="duplicateDataset"
                >
                  Dupliquer
                </b-button>
                <b-button
                  variant="primary"
                  style="float: right"
                  @click="handleSubmit(saveDataset)"
                >
                  Enregistrer
                </b-button>
              </div>
            </div>
          </b-col>
        </b-row>
      </ValidationObserver>
    </b-container>
    <DeleteDataset
      :open="deletingDataset"
      :dataset="currentDataset"
      @hide="deletingDataset = false"
      @update="$router.push({ name: 'Datasets' })"
    />
    <ChangeDatasetPermissions
      :open="changingDatasetPermissions"
      @update="changePermissionLevel"
      @hide="changingDatasetPermissions = false"
    />
  </div>
</template>

<script>
import  { mapState, mapMutations, mapActions } from 'vuex';

import datasetsAPI from '@/api/datasetsAPI.js';

import DatasetCard from '@/components/Cards/DatasetCard.vue';
import DatasetForm from '@/components/Forms/DatasetForm.vue';
import FileUploadResourceEditor from '@/components/ResourceEditors/FileUploadResourceEditor.vue';
import FTPResourceEditor from '@/components/ResourceEditors/FTPResourceEditor.vue';
import HrefResourceEditor from '@/components/ResourceEditors/HrefResourceEditor.vue';
import AddAnnexe from '@/components/Forms/AddAnnexe.vue';
import ResourceCreator from '@/components/ResourceCreator.vue';
import DeleteDataset from '@/components/Modals/DeleteDataset.vue';
import ChangeDatasetPermissions from '@/components/Modals/ChangeDatasetPermissions.vue';
import Multiselect from 'vue-multiselect';

import { ValidationObserver } from 'vee-validate';

export default {
  name: 'DatasetDetail',

  components: {
    DatasetCard,
    DatasetForm,
    FileUploadResourceEditor,
    FTPResourceEditor,
    HrefResourceEditor,
    AddAnnexe,
    ResourceCreator,
    DeleteDataset,
    ChangeDatasetPermissions,
    Multiselect,
    ValidationObserver,
  },

  data() {
    return {
      busy: false,
      loading: false,
      loadingResource: false,
      loadingAnnexe: false,
      reLoadindResource: false,
      deletingDataset: false,
      form: {
        display_name: null,
        description: null,
        keywords: [],
        categories: [],
        topics: [],
        kinds: [],
        recommendation: null,
        restriction: null,
        usergroup: null,
        datasetContacts: [],
        licence: null,
        copyright: null,
        granularity: null,
        coverage: null,
        frequence: null,
        publicationDate: null,
        lastUpdateDate: null,
        creationDate: null,
        revisionDate: null,
        year: null,
        lineage: null,
        resource: {
          format: null,
          display_name: null,
          description: null,
          file: null
        },
        thumbnail: null
      },
      newResource: null,
      isAddingAnnexe: false,
      coverageOptions: [
        { label: 'Région', code: 0 },
        { label: 'Territoire de compétence de l\'organisation', code: 1 },
        { label: 'Calculée sur la donnée', code: 2 }
      ],
      permissionLevels: [
        {
          label: 'Donnée privée',
          code: 0
        },
        {
          label: 'Recherche',
          code: 1
        },
        {
          label: 'Consultation',
          code: 2
        },
        {
          label: 'Téléchargement',
          code: 3
        }
      ],
      permissionLevel: null,
      changingDatasetPermissions: false,
      permissionsLevelToChange: null,
      cardKey: 1
    };
  },

  computed: {
    ...mapState('datasets', [
      'currentDataset',
      'datasetsCategories',
      'datasetsGranularities',
      'datasetsLicences',
      'datasetsTopics',
      'datasetsRestrictions',
      'datasetsKinds',
      'datasetsUpdateFrequencies'
    ]),
    ...mapState('organisations', [
      'organisationsList'
    ]),
    ...mapState('resources', [
      'resourcesList',
      'resourceInspectionData'
    ]),
    resourceData() {
      return this.resourcesList.filter(resourceEl => {
        return resourceEl.datasets.find(datasetEl => {
          return (
            datasetEl.dataset_id === this.currentDataset.id &&
            datasetEl.type.id === 0
          )
        })
      })[0];
    },
    source() {
      return this.resourcesList.filter(resourceEl => {
        return resourceEl.datasets.find(datasetEl => {
          return (
            datasetEl.dataset_id === this.currentDataset.id &&
            datasetEl.type.id === 1
          )
        })
      })[0];
    },
    annexes() {
      return this.resourcesList.filter(resourceEl => {
        return resourceEl.datasets.find(datasetEl => {
          return (
            datasetEl.dataset_id === this.currentDataset.id &&
            datasetEl.type.id === 2
          )
        })
      });
    }
  },

  created() {
    // Clean stored form
    this.SET_CURRENT_FORM({
      id: null,
      form: null
    });

    this.loading = true;
    this.GET_DATASET_DETAIL(this.$route.params.id)
    .then(() => {
      this.SET_RESOURCES_FILTERS({
        filter: 'dataset_id',
        value: this.currentDataset.id
      });
      this.GET_RESOURCES_LIST()
      .then(() => {
        this.initForm();
        this.loading = false;
      });
    });
    if (this.organisationsList.length === 0) {
      this.GET_ORGANISATIONS_LIST({
        direction: null,
        field: null,
        page: 1
      });
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.deletingDataset = false;
      this.changingDatasetPermissions = false;
    });
    if (this.organisationsList.length === 1 && !this.form.organisation) {
      this.form.organisation = this.organisationsList[0];
    }
  },

  methods: {
    ...mapMutations([
      'SET_RELOAD_INTERVAL_ID',
      'CLEAR_RELOAD_INTERVAL_ID'
    ]),
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('resources', [
      'SET_RESOURCES_FILTERS',
      'REMOVE_RESOURCES_FILTERS',
      'SET_RESOURCE_INSPECTION_DATA'
    ]),
    ...mapMutations('datasets', [
      'SET_DUPLICATED_DATASET'
    ]),
    ...mapActions('datasets', [
      'GET_DATASETS_CATEGORIES',
      'GET_DATASETS_GRANULARITIES',
      'GET_DATASETS_LICENCES',
      'GET_DATASETS_TOPICS',
      'GET_DATASETS_KINDS',
      'GET_DATASETS_RESTRICTIONS',
      'GET_DATASETS_UPDATE_FREQUENCIES',
      'GET_DATASET_DETAIL',
      'GET_DATASETS_LIST',
      'UPDATE_DATASET',
      'PATCH_DATASET'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST'
    ]),
    ...mapActions('resources', [
      'GET_RESOURCES_LIST',
      'INSPECT_FILE_UPLOAD',
      'INSPECT_FTP',
      'INSPECT_HREF',
      'CREATE_FILE_UPLOAD_RESOURCE',
      'CREATE_FTP_RESOURCE',
      'CREATE_HREF_RESOURCE',
      'UPDATE_RESOURCE_FILE',
      'UPDATE_FILE_UPLOAD_RESOURCE',
      'UPDATE_FTP_RESOURCE',
      'UPDATE_HREF_RESOURCE',
      'DELETE_RESOURCE_FILE',
    ]),
    ...mapActions('dashboard', [
      'GET_DASHBOARD_TASKS'
    ]),

    async getConfigData() {
      if (this.datasetsCategories.length === 0) {
        await this.GET_DATASETS_CATEGORIES();
      }
      if (this.datasetsGranularities.length === 0) {
        await this.GET_DATASETS_GRANULARITIES();
      }
      if (this.datasetsLicences.length === 0) {
        await this.GET_DATASETS_LICENCES();
      }
      if (this.datasetsTopics.length === 0) {
        await this.GET_DATASETS_TOPICS();
      }
      if (this.datasetsKinds.length === 0) {
        await this.GET_DATASETS_KINDS();
      }
      if (this.datasetsRestrictions.length === 0) {
        await this.GET_DATASETS_RESTRICTIONS();
      }
      if (this.datasetsUpdateFrequencies.length === 0) {
        await this.GET_DATASETS_UPDATE_FREQUENCIES();
      }
    },

    initForm() {
      this.getConfigData()
        .then(() => {
          this.form.display_name = this.currentDataset.display_name;
          this.form.thumbnail = this.currentDataset.thumbnail;
          this.form.description = this.currentDataset.description;
          this.form.usergroup = this.currentDataset.usergroup;
          let position = 1;
          this.form.datasetContacts.splice(0);
          for (const contact of this.currentDataset.contacts) {
            contact.position = position;
            this.form.datasetContacts.push(contact);
            position += 1;
          }
          this.form.categories = this.currentDataset.categories.map(el => el.display_name);
          this.form.topics = this.currentDataset.topics.map(el => el.display_name);
          this.form.kinds = this.currentDataset.kinds.map(el => el.id);
          this.form.licence = this.currentDataset.license;
          this.form.copyright = this.currentDataset.copyright;
          this.form.granularity = this.currentDataset.granularity ? this.currentDataset.granularity : '';
          this.form.coverage =
            this.coverageOptions.find(el => el.code === this.currentDataset.geographical_coverage) ?
              this.coverageOptions.find(el => el.code === this.currentDataset.geographical_coverage) : '';
          this.form.keywords = this.currentDataset.tags;
          this.form.recommendation = this.currentDataset.recommendation;
          this.form.restriction = this.currentDataset.restriction ?
            this.datasetsRestrictions.find(el => el === this.currentDataset.restriction) ?
              this.datasetsRestrictions.find(el => el === this.currentDataset.restriction) :
              this.currentDataset.restriction :
            null;
          this.form.publicationDate = this.currentDataset.publication_date ? this.currentDataset.publication_date.slice(0, 10) : '';
          this.form.lastUpdateDate = this.currentDataset.last_update_date ? this.currentDataset.last_update_date.slice(0, 10) : '';
          this.form.creationDate = this.currentDataset.creation_date ? this.currentDataset.creation_date : null;
          this.form.revisionDate = this.currentDataset.last_revision_date ? this.currentDataset.last_revision_date : null;
          this.form.frequence =
            this.currentDataset.update_frequency ?
              this.datasetsUpdateFrequencies.find(el => el.value === this.currentDataset.update_frequency) :
              null,
          this.form.year = this.currentDataset.year;
          this.form.lineage = this.currentDataset.lineage;
          this.permissionLevel = this.permissionLevels.find(el => el.code === this.currentDataset.default_permission_level);

          this.cardKey += 1;
        });
    },

    setForm(e) {
      this.form = e;
    },

    async afterResourceChange() {
      this.loading = true;
      this.isAddingAnnexe = false;
      await datasetsAPI.buildDatasetIndex(this.$route.params.id);
      this.GET_DATASET_DETAIL(this.$route.params.id)
        .then(() => {
          this.SET_RESOURCES_FILTERS({
            filter: 'dataset_id',
            value: this.currentDataset.id
          });
          this.GET_RESOURCES_LIST();
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });
    },

    askForChangePermissionLevel(e) {
      this.changingDatasetPermissions = true;
      this.permissionsLevelToChange = e;
    },

    changePermissionLevel() {
      const data = {
        default_permission_level: this.permissionsLevelToChange.code
      };
      this.busy = true;
      this.PATCH_DATASET({
        id: this.currentDataset.id,
        data: data
      })
        .then(() => {
          this.permissionsLevelToChange = null;
          this.GET_DATASET_DETAIL(this.$route.params.id)
            .then(() => {
              this.busy = false;
            })
            .catch(() => {
              this.busy = false;
            });
        })
        .catch(() => {
          this.permissionsLevelToChange = null;
          this.busy = false;
        });
    },

    updateFileUploadFile(e) {
      if (e.type === 'resource') {
        this.loadingResource = true;
      } else if (e.type === 'annexe') {
        this.loadingAnnexe = true;
      } else {
        this.loading = true;
      }
      this.UPDATE_RESOURCE_FILE(e)
        .then(() => {
          const data = {
            kwargs: {
              usergroup_pk: this.currentDataset.usergroup.id,
              dataset_id: this.currentDataset.id,
              target: {
                app_label: 'onegeo_dataset',
                model: 'dataset',
                pk: this.currentDataset.id
              }
            }
          };

          this.UPDATE_FILE_UPLOAD_RESOURCE({
            type: e.type,
            data: data,
            datasetId: this.currentDataset.id,
            resourceId: this.source.id
          })
            .then(() => {
              this.GET_DATASET_DETAIL(this.$route.params.id)
                .then(() => {
                  this.SET_RESOURCES_FILTERS({
                    filter: 'dataset_id',
                    value: this.currentDataset.id
                  });
                  this.GET_RESOURCES_LIST();
                  this.loadingResource = false;
                  this.loadingAnnexe = false;
                  this.loading = false;
                })
                .catch(() => {
                  this.loadingResource = false;
                  this.loadingAnnexe = false;
                  this.loading = false;
                });
              this.afterCreationRequests();
            })
            .catch((err) => {
              console.error(err);
              this.loadingResource = false;
              this.loadingAnnexe = false;
              this.loading = false;
            });
        })
        .catch((err) => {
          console.error(err);
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.loadingResource = false;
          this.loadingAnnexe = false;
          this.loading = false;
        });
    },

    updateFTPFile(e) {
      if (e.type === 'resource') {
        this.loadingResource = true;
      } else if (e.type === 'annexe') {
        this.loadingAnnexe = true;
      } else {
        this.loading = true;
      }
      const data = {
        id: e.id,
        href: e.selectedFtpFiles.map(el => el.value),
        kwargs: {
          target: {
            app_label: 'onegeo_dataset',
            model: 'dataset',
            pk: this.currentDataset.id
          }
        }
      };
      this.UPDATE_FTP_RESOURCE({
        type: e.type,
        data: data,
        datasetId: this.currentDataset.id,
        resourceId: this.source.id
      })
        .then(() => {
          this.GET_DATASET_DETAIL(this.$route.params.id)
            .then(() => {
              this.SET_RESOURCES_FILTERS({
                filter: 'dataset_id',
                value: this.currentDataset.id
              });
              this.GET_RESOURCES_LIST();
              this.loadingResource = false;
              this.loadingAnnexe = false;
              this.loading = false;
              this.afterCreationRequests();
            })
            .catch(() => {
              this.loadingResource = false;
              this.loadingAnnexe = false;
              this.loading = false;
            });
        })
        .catch((err) => {
          console.error(err);
          this.loadingResource = false;
          this.loadingAnnexe = false;
          this.loading = false;
        });
    },

    updateHrefFile() {
      const data = {
        kwargs: {
          usergroup_pk: this.currentDataset.usergroup.id,
          dataset_id: this.currentDataset.id,
          target: {
            app_label: 'onegeo_dataset',
            model: 'dataset',
            pk: this.currentDataset.id
          }
        }
      };
      this.UPDATE_HREF_RESOURCE({
        data: data,
        datasetId: this.currentDataset.id
      })
        .then(() => {
          this.GET_DATASET_DETAIL(this.$route.params.id)
            .then(() => {
              this.SET_RESOURCES_FILTERS({
                filter: 'dataset_id',
                value: this.currentDataset.id
              });
              this.GET_RESOURCES_LIST();
              this.loading = false;
              this.afterCreationRequests();
            })
            .catch(() => {
              this.loading = false;
            });
        })
        .catch((err) => {
          console.error(err);
          this.loading = false;
        });
    },

    duplicateDataset() {
      this.loading = true;
      this.SET_DUPLICATED_DATASET(this.currentDataset);
      this.$router.push({
        name: 'AddDataset'
      })
        .then(() => {
          this.loading = false;
        })
        .catch(() => {
          this.loading = false;
        });
    },

    async saveDataset() {
      if (this.$refs.resourceComponent) {
        this.$refs.resourceComponent.updateResourceInfos();
      }
      if (this.$refs.annexComponent && this.$refs.annexComponent.length) {
        for (const annexComponent of this.$refs.annexComponent) {
          annexComponent.updateResourceInfos();
        }
      }

      const data = {
        ...this.currentDataset,
        ...this.form.display_name && { display_name: this.form.display_name },
        ...this.form.description && { description: this.form.description },
        ...this.form.usergroup.id && { usergroup: this.form.usergroup.id },
        contacts: this.form.datasetContacts.map(({ position, ...el }) => { return el }),
        categories: this.datasetsCategories.filter(el => this.form.categories.includes(el.display_name)),
        topics: this.datasetsTopics.filter(el => this.form.topics.includes(el.display_name)),
        kinds: this.datasetsKinds.filter(el => this.form.kinds.includes(el.id)),
        tags: this.form.keywords,
        ...this.form.recommendation && { recommendation: this.form.recommendation },
        ...this.form.restriction && { restriction: this.form.restriction },
        ...this.form.licence && { license: this.form.licence },
        ...this.form.copyright && { copyright: this.form.copyright },
        ...this.form.granularity && { granularity: this.form.granularity },
        ...this.form.coverage && { geographical_coverage: this.form.coverage.code },
        ...this.form.publicationDate && {
          publication_date: new Date(this.form.publicationDate).toISOString().split('T')[0]
        },
        ...this.form.lastUpdateDate && {
          last_update_date: new Date(this.form.lastUpdateDate).toISOString().split('T')[0]
        },
        ...this.form.year && { year: this.form.year },
        ...this.form.lineage && { lineage: this.form.lineage },
        ...this.form.frequence && { update_frequency: this.form.frequence.value }
      };
      this.loading = true;
      if (this.form.thumbnail instanceof FormData) {
        await datasetsAPI.setDatasetThumbnail(this.currentDataset.id, this.form.thumbnail)
      }
      this.UPDATE_DATASET({
        id: this.currentDataset.id,
        data: data
      })
        .then(() => {
          this.GET_DATASET_DETAIL(this.currentDataset.id)
            .then(() => {
              this.initForm();
            });
          this.GET_DATASETS_LIST({
            direction: null,
            field: null
          });
          this.loading = false;
        })
        .catch((err) => {
          console.error(err);
        });
    },
    askToDeleteDataset() {
      this.deletingDataset = true;
    },
    deleteDataset() {

    },

    setResource(e) {
      this.newResource = e;
    },

    createResource() {
      this.loadingResource = true;
      if (this.newResource.type === 'file-upload') {
        this.createFileUploadResource();
      } else if (this.newResource.type === 'ftp') {
        this.createFTPResource();
      } else if (this.newResource.type === 'href') {
        this.createHrefResource(this.newResource.href);
      }
    },

    // Function to check if resource creation is still pending
    checkResourceCreation() {
      if (
        this.currentDataset.resource_source &&
        this.currentDataset.resource_source._processing &&
        this.currentDataset.resource_source._processing.state === 'PENDING'
      ) {
        this.reLoadindResource = true;
        this.GET_DATASET_DETAIL(this.$route.params.id)
          .then(() => {
            this.SET_RESOURCES_FILTERS({
              filter: 'dataset_id',
              value: this.currentDataset.id
            });
            this.GET_RESOURCES_LIST()
              .then(() => {
                this.reLoadindResource = false;
              })
              .catch(() => {
                this.reLoadindResource = false;
              });
          })
          .catch(() => {
            this.reLoadindResource = false;
          })
      } else {
        this.CLEAR_RELOAD_INTERVAL_ID();
      }
    },

    createFileUploadResource() {
      const resourceData = {
        ...this.newResource,
        organisation: this.currentDataset.usergroup.id,
      };
      this.INSPECT_FILE_UPLOAD(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.currentDataset.usergroup.id,
                dataset_id: this.currentDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.currentDataset.id
                }
              }
            };
            this.CREATE_FILE_UPLOAD_RESOURCE({ data: data, async: true })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.loadingResource = false;
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch(() => {
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.loadingResource = false;
        });
    },

    createFTPResource() {
      const resourceData = {
        ...this.newResource,
        data_format: this.newResource.format.codename,
        href: this.newResource.selectedFtpFiles.map(el => el.value),
      };
      this.INSPECT_FTP(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.currentDataset.usergroup.id,
                dataset_id: this.currentDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.currentDataset.id
                }
              }
            };
            this.CREATE_FTP_RESOURCE({ data: data, async: true })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.loadingResource = false;
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch(() => {
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.loadingResource = false;
        });
    },

    createHrefResource() {
      const resourceData = {
        ...this.newResource,
        data_format: this.newResource.format.codename,
        href: this.newResource.href,
      };
      this.INSPECT_HREF(resourceData)
        .then(() => {
          if (this.resourceInspectionData) {
            const data = {
              kwargs: {
                resource__display_name: resourceData.display_name,
                resource__description: resourceData.description,
                resource__kind: resourceData.kind,
                resource__last_update_date: resourceData.last_update_date,
                usergroup_pk: this.currentDataset.usergroup.id,
                dataset_id: this.currentDataset.id,
                target: {
                  app_label: 'onegeo_dataset',
                  model: 'dataset',
                  pk: this.currentDataset.id
                }
              }
            };
            this.CREATE_HREF_RESOURCE({ data: data, async: false })
              .then(() => {
                this.afterCreationRequests();
              })
              .catch((err) => {
                console.error(err);
                this.loadingResource = false;
              });
          } else {
            this.afterCreationRequests();
          }
        })
        .catch((err) => {
          console.error(err);
          this.SET_RESOURCE_INSPECTION_DATA(null);
          this.loadingResource = false;
        });
    },

    // Fired after each resource creation
    afterCreationRequests() {
      this.GET_RESOURCES_LIST({
        direction: null,
        field: null
      });
      this.SET_CURRENT_FORM({
        id: null,
        form: null
      });
      this.GET_DASHBOARD_TASKS({
        direction: null,
        field: null
      });
      this.GET_DATASET_DETAIL(this.currentDataset.id);
      this.loadingResource = false;
      // Fetch data periodically to retrieve resource creation status
      this.SET_RELOAD_INTERVAL_ID(
        setInterval(() => {
          this.checkResourceCreation()
        },
        process.env.VUE_APP_RELOAD_INTERVAL)
      );
    },
  }
}
</script>

<style lang="less" scoped>

.card-permissions-container {
  position: sticky;
  top: 10%;
  width: 100%;
  margin: 0 auto;

  .permissions-dropdown {
    width: 80%;
    margin: 0 10% 2em;
  }
}

</style>
